/*
* Code by Bodysoulspirit. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
					  "title" : "Make Hue Color List",
					  "keywords" : [],
						"description" : "Creates a given amount color list along hue",
					  "version" : "1.0.0",
					  },
					  "node" : {
						  "exampleCompositions" : []
					  }
				  });

void nodeEvent
(
		VuoInputData(VuoReal, {"default":1, "suggestedMin":0.0, "suggestedMax":1.0, "suggestedStep":0.1}) saturation,
		VuoInputData(VuoReal, {"default":0.5, "suggestedMin":0.0, "suggestedMax":1.0, "suggestedStep":0.1}) lightness,
		VuoInputData(VuoReal, {"default":1, "suggestedMin":0.0, "suggestedMax":1.0, "suggestedStep":0.1}) opacity,
		VuoInputData(VuoInteger, {"default":5, "suggestedMin":1}) amount,
		VuoOutputData(VuoList_VuoColor) colorList
)
{
	*colorList = VuoListCreate_VuoColor();
	VuoReal realint = amount;
	for (VuoInteger i = 0; i < amount; ++i)
	{
		VuoReal hue = i*(1/realint);
		VuoListAppendValue_VuoColor(*colorList, VuoColor_makeWithHSLA(hue, saturation, lightness, opacity));
	}
}
