/*
* Code by Bodysoulspirit. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
					 "title" : "Make Points along Circle",
					 "keywords" : [],
					 "description" : "Creates a 2D Points list along a circle, starting at the top middle",
					 "version" : "2.0.0",
});

void nodeEvent
(
	VuoInputData(VuoReal, {"default":1.0, "suggestedStep":0.1}) radius,
	VuoInputData(VuoInteger, {"default":10, "suggestedStep":1}) sides,
	VuoInputData(VuoBoolean, {"default":true}) closeCircle,
	VuoOutputData(VuoList_VuoPoint2d) positions
)
{
*positions = VuoListCreate_VuoPoint2d();

for(int i=0;i<sides;i++){
	VuoReal angle = (i*2*M_PI/sides)+(M_PI/2);
	VuoPoint2d item = {(radius*cos(angle)),(radius*sin(angle))};
	VuoListAppendValue_VuoPoint2d(*positions, item);
	}

if (closeCircle == true){
	VuoPoint2d firstItem = VuoListGetValue_VuoPoint2d(*positions, 1);
	VuoListAppendValue_VuoPoint2d(*positions, firstItem);
	}

}
